﻿Public Class frmSortedList
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim sList As New System.Collections.SortedList

        ' USE THE COMMENTED LINES TO CREATE A SORTEDLIST WITH
        ' DATES AS KEYS AND NAMES AS VALUES
        'sList.Add(#4/5/1990#, "Andrea")
        'sList.Add(#1/12/1989#, "Joe")
        'sList.Add(#12/22/2000#, "Albert")
        'sList.Add(#8/8/1965#, "Elisabeth")
        'sList.Add(#11/11/1971#, "Robert")
        'sList.Add(#3/9/1998#, "Mary Ann")
        'sList.Add(#9/20/1999#, "Alice")
        'sList.Add(#4/9/2004#, "Nicole")
        'sList.Add(#10/2/2001#, "Bruce")
        'sList.Add(#5/25/1985#, "Andrea")
        sList.Add(116, "item 3")
        sList.Add(110, "item 9")
        sList.Add(115, "item 4")
        sList.Add(217, "item 2")
        sList.Add(211, "item 8")
        sList.Add(214, "item 5")
        sList.Add(318, "item 1")
        sList.Add(312, "item 7")
        sList.Add(319, "item 0")
        sList.Add(313, "item 6")

        Dim SLEnum As IDictionaryEnumerator
        SLEnum = sList.GetEnumerator()
        ListBox1.Items.Clear()

        ListBox1.Items.Add("The HashTable's Keys and Values")
        While SLEnum.MoveNext
            ListBox1.Items.Add("Key = " & SLEnum.Key.ToString & ", Value= " & SLEnum.Value.ToString)
        End While

        ListBox1.Items.Add("The HashTable's Values by Index")
        Dim idx As Integer
        For idx = 0 To sList.Count - 1
            ListBox1.Items.Add("Item " & sList.GetByIndex(idx).ToString & " is at location " & sList.IndexOfValue(sList.GetByIndex(idx)).ToString)
        Next

        ListBox1.Items.Add("The HashTable's Keys by Index")
        For idx = 0 To sList.Count - 1
            ListBox1.Items.Add("The key at location " & idx.ToString & " is " & sList.GetKey(idx).ToString)
        Next

        Debug.WriteLine("Index of Item 7: " & sList.IndexOfValue("item 7"))
        Debug.WriteLine("Index of Key 211: " & sList.IndexOfKey(211))

    End Sub

    Class CustomComparer : Implements IComparer
        Public Function Compare(ByVal o1 As Object, _
                                ByVal o2 As Object) As Integer _
                                Implements IComparer.Compare
            Dim num1, num2 As Integer
            Try
                num1 = CType(o1, Integer)
                num2 = CType(o2, Integer)
            Catch compareException As System.Exception
                Throw (compareException)
                Exit Function
            End Try
            If Math.Cos(num1) < Math.Cos(num2) Then
                Return -1
            Else
                If Math.Cos(num1) > Math.Cos(num2) Then
                    Return 1
                Else
                    Return 0
                End If
            End If
        End Function
    End Class

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim sList As New System.Collections.SortedList(New CustomComparer)
        ' Populate SortedList
        sList.Add(116, "item 3")
        sList.Add(110, "item 9")
        sList.Add(115, "item 4")
        sList.Add(217, "item 2")
        sList.Add(211, "item 8")
        sList.Add(214, "item 5")
        sList.Add(318, "item 1")
        sList.Add(312, "item 7")
        sList.Add(319, "item 0")
        sList.Add(313, "item 6")
        ListBox1.Items.Clear()
        Dim SLEnum As IDictionaryEnumerator = sList.GetEnumerator
        While SLEnum.MoveNext
            ListBox1.Items.Add("Key = " & SLEnum.Key.ToString & ", Value= " & _
                              SLEnum.Value.ToString & ",   Cos(key) = " & _
                              Math.Cos(CType(SLEnum.Key, Double)))
        End While
    End Sub

    Private Sub frmSortedList_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
End Class
